package io.reisub.dreambot.cagility.tasks;

import io.reisub.dreambot.util.Constants;
import io.reisub.dreambot.util.Util;
import org.dreambot.api.methods.Calculations;
import org.dreambot.api.methods.MethodContext;
import org.dreambot.api.methods.MethodProvider;
import org.dreambot.api.methods.container.impl.Inventory;
import org.dreambot.api.methods.interactive.Players;
import org.dreambot.api.methods.item.GroundItems;
import org.dreambot.api.script.TaskNode;
import org.dreambot.api.utilities.impl.Condition;
import org.dreambot.api.wrappers.items.GroundItem;
import org.dreambot.api.wrappers.items.Item;

public class PickupMark extends TaskNode {
    public static int marksPickedUp = 0;

    @Override
    public boolean accept() {
        GroundItem mark = GroundItems.closest(Constants.MARK_OF_GRACE);

        return mark != null && mark.canReach() && Util.playerIsIdle();
    }

    @Override
    public int execute() {
        GroundItem mark = GroundItems.closest(Constants.MARK_OF_GRACE);

        if (mark == null || !mark.canReach()) return 0;

        Item marks = Inventory.get(Constants.MARK_OF_GRACE);
        final int count = marks == null ? 0 : marks.getAmount();

        mark.interactForceLeft(Constants.TAKE);

        if (MethodContext.sleepUntil(() -> {
            Item currentMarks = Inventory.get(Constants.MARK_OF_GRACE);
            return currentMarks != null && currentMarks.getAmount() > count;
        }, () -> Players.localPlayer().isMoving(), Calculations.random(1200, 1300), 50)) {
            marksPickedUp++;
        };

        return Calculations.random(250, 400);
    }
}
