package io.reisub.dreambot.cshopper.tasks;

import io.reisub.dreambot.cshopper.CShopper;
import io.reisub.dreambot.cshopper.ItemWrapper;
import org.dreambot.api.methods.Calculations;
import org.dreambot.api.methods.container.impl.Inventory;
import org.dreambot.api.methods.container.impl.Shop;
import org.dreambot.api.methods.world.World;
import org.dreambot.api.methods.world.Worlds;
import org.dreambot.api.methods.worldhopper.WorldHopper;
import org.dreambot.api.script.TaskNode;

import java.util.LinkedList;
import java.util.List;
import java.util.Queue;

public class Hop extends TaskNode {
    private final Queue<World> worlds;

    public Hop(boolean members) {
        List<World> worldsList = Worlds.all(world -> world.isMembers() == members && world.isNormal() && !world.isHighRisk() && !world.isPVP());

        worlds = new LinkedList<>(worldsList);
    }

    public Hop() {
        this(true);
    }

    @Override
    public boolean accept() {
        if (!Shop.isOpen()) return false;

        for (ItemWrapper iw : CShopper.getConfiguration().getItems()) {
            int shopCount = Shop.get(iw.getName()).getAmount();

            int inventoryCount = 0;
            if (Inventory.get(iw.getName()) != null) {
                inventoryCount = Inventory.get(iw.getName()).getAmount();
            }

            if (shopCount > iw.getMinimumInShop() && inventoryCount < iw.getBuyTotal()) return false;
        }

        return true;
    }

    @Override
    public int execute() {
        World world = worlds.poll();
        worlds.add(world);

        if (world != null) {
            WorldHopper.hopWorld(world);

        }
        return Calculations.random(200, 400);
    }
}
