package io.reisub.dreambot.util;

import org.dreambot.api.methods.Calculations;
import org.dreambot.api.script.TaskNode;

public abstract class TaskNodeParent extends TaskNode {
    private TaskNode[] children;

    public void setChildren(TaskNode... children) {
        this.children = children;
    }

    public boolean accept() {
        for (TaskNode n : children) {
            if (n.accept()) {
                return true;
            }
        }

        return false;
    }

    @Override
    public int execute() {
        for (TaskNode n : children) {
            if (n.accept()) {
                return n.execute();
            }
        }

        return Calculations.random(40, 80);
    }
}
