package io.reisub.dreambot.util.tasks.kitten;

import io.reisub.dreambot.util.CNPC;
import io.reisub.dreambot.util.Constants;
import org.dreambot.api.methods.Calculations;
import org.dreambot.api.methods.MethodContext;
import org.dreambot.api.methods.container.impl.Inventory;
import org.dreambot.api.script.TaskNode;
import org.dreambot.api.wrappers.interactive.NPC;

public class FeedKitten extends TaskNode {
    private final KittenTask parent;

    public FeedKitten(KittenTask parent) {
        this.parent = parent;
    }

    @Override
    public boolean accept() {
        NPC kitten = CNPC.getNPCInteractingWithPlayer(Constants.KITTEN);

        return parent.isHungry() &&
                Inventory.contains(parent.fishItemFilter) &&
                kitten != null &&
                kitten.canReach();
    }

    @Override
    public int execute() {
        NPC kitten = CNPC.getNPCInteractingWithPlayer(Constants.KITTEN);

        if (kitten == null) return 0;

        Inventory.get(parent.fishItemFilter).useOn(kitten);

        MethodContext.sleepUntil(() -> !parent.isHungry(), Calculations.random(5000, 5500));

        return Calculations.random(250, 400);
    }
}
